Java 11兼容旧项目的一些注意点

原创
2019/10/15 11:06
阅读数 1.7K

众所周知,Oracle的Java8已经停更,Java11是下一个LTS版本。近期打算对一些旧项目升级到Java11,在这里记下一些需要注意的兼容性问题

  1. javax.xml.bind.JAXBException ClassNotFound问题

JAXB api是java EE的API,在java SE 9中开始便不再包含这个包,在 6/7/8年代都是绑定在一块的 解决方案就是手工添加jar包。 如果用的是maven,可以添加以下依赖

<!-- Java 6 = JAX-B Version 2.0   -->
<!-- Java 7 = JAX-B Version 2.2.3 -->
<!-- Java 8 = JAX-B Version 2.2.11 -->
<dependencies>
    <dependency>
        <groupId>javax.xml.bind</groupId>
        <artifactId>jaxb-api</artifactId>
        <version>2.2.11</version>
    </dependency>
    <dependency>
        <groupId>com.sun.xml.bind</groupId>
        <artifactId>jaxb-impl</artifactId>
        <version>2.2.11</version>
    </dependency>
    <dependency>
        <groupId>com.sun.xml.bind</groupId>
        <artifactId>jaxb-core</artifactId>
        <version>2.2.11</version>
    </dependency>
    <dependency>
        <groupId>javax.activation</groupId>
        <artifactId>activation</artifactId>
        <version>1.1.1</version>
    </dependency>
</dependencies>
  1. java.lang.NoClassDefFoundError: javax/xml/ws/EndpointReference异常

问题原因同上边第1点描述一样,从java9开始分离了,单独引入即可

<dependency>
	<groupId>javax.xml.ws</groupId>
	<artifactId>jaxws-api</artifactId>
	<version>2.2.12</version>
</dependency>
  1. 关于com.sun.image.codes相关包的NoClassDefFound异常

这个问题貌似无解,找了很久没有从maven仓库找到可以替换的包,当然这个好像是因为这是sun公司自己API,如果你用的是openjdk,那么问题迎刃而解。如果不幸你用的是oracle的JDK,那么还是更换相关类,使用java的imageIO相关API吧,或者更换相关依赖的组件。

  1. WebService相关包的NoClassDefFound异常

引入以下包解决

<dependency>
	<groupId>javax.xml.ws</groupId>
	<artifactId>jaxws-api</artifactId>
	<version>2.2.12</version>
</dependency>

<dependency>
	<groupId>javax.jws</groupId>
	<artifactId>javax.jws-api</artifactId>
	<version>1.1</version>
</dependency>
展开阅读全文
打赏
0
0 收藏
分享
加载中
更多评论
打赏
0 评论
0 收藏
0
分享
返回顶部
顶部